#include <stdlib.h>
#include <unistd.h>
#include <sys/file.h>
#include <sys/types.h>
#include "kernel.h"
#include <errno.h>
#include <sys/stat.h>
#include <sys/time.h>
#include <sys/ioctl.h>
#include <signal.h>
#include <sys/socket.h>
#include <arpa/inet.h>
#include <netdb.h>
#include <fcntl.h>
#include "idlookup.h"
#include "client.h"

#include <stdarg.h>

#include "mud.h"
#include "log.h"
#include "bootstrap.h"
#include "sendsys.h"
#include "mobile.h"
#include "commands.h"
#include "timing.h"
#include "exit.h"
#include "locations.h"
#include "pflags.h"
#include "update.h"
#include "climate.h"
#include "reboot.h"
#include "objsys.h"
#include "bprintf.h"
#include "zones.h"
#include "uaf.h"
#include "fight.h"
#include "rooms.h"
#include "sflags.h"
#include "locations.h"
#define F_OK 0

void check_pid (void);
void do_packet (int, char *);
void rm_pid (void);
void write_packet (int fd);
void close_sock(int);
void setup_io(int, int);
void flush_mud(Boolean);

static int xmain (void);
static int xmain_reboot (void);
static int go_background (void);
static void exec_cmd (int, char *);
static void get_options (int argc, char **argv);
static void usage (void);
static void fullusage (void);
static void new_connection (int fd);
static void read_packet (int fd);
static void sig_handler (int sig);
static void main_loop (int listen_socket);

fd_set input_set, output_set, exception_set;
Boolean clear_syslog_file = CLEAR_SYSLOG;
Boolean stay_foreground   = FOREGROUND;
Boolean sig_term_happened = False;
Boolean auto_open         = AUTO_OPEN;
Boolean kill_other_mud    = KILL_MUD;
Boolean quiet             = QUIET;
char *data_dir            = DATA_DIR;
int mud_port              = PORT;
int old_proc_num          = 0;
int update                = 0;
int main_socket           = -1;
int width                 = 0;

#ifdef IO_STATS
  int bytes_sent          = 0;                   /* total bytes sent */
  int bytes_read          = 0;                   /* total bytes read */
  int unres_hosts         = 0;                   /* unresolved hosts */
  int cut_conns           = 0;                   /* cut connections */
  int sock_conns          = 0;                   /* total connections */
#endif

extern int aberfd;
extern Boolean auth;
extern Boolean aber_output;

extern int dnsfd;
Boolean dns_output;

#ifdef _OLD_LINUX_
extern char *sys_errlist[];
#endif

extern void quit_player (int);
extern void scatter_potions (void);
extern void close_mudfiles (void);
extern void wipe_duration(int);
