#ifndef _PFLAGS_H
#define _PFLAGS_H

/* iDiRT
 * Privelige Flag Definitions (pflags)
 */

/* Protection bits */
#define	PFL_NOEXOR	0	/* Can not be exo'd			*/
#define	PFL_NOSNOOP	1	/* Can not be snooped			*/
#define	PFL_NOHASSLE	2	/* Can not be attacked or magic'd	*/
#define	PFL_NOALIAS	3	/* Can not be aliased into		*/
#define PFL_NOZAP	4	/* Can not be zapped			*/
#define PFL_NOSUMMON	5	/* Can not be summoned			*/
#define PFL_NOTRACE	6	/* Can not be traced			*/
#define PFL_NOSTEAL	7	/* You cannot steal from him		*/
#define PFL_NOFORCE	8	/* Can not be forced			*/
#define PFL_NOPUNT	9	/* Can not be punted			*/
#define PFL_NOFORGET	10	/* Can not be forgotten			*/
#define	PFL_NOBURN	11	/* Can not be burned			*/
#define PFL_NOSIC	12	/* Can not be sic'd			*/
#define PFL_EDITOR	13	/* Can use the editor ("edit" command)	*/
#define PFL_NOPROBATION 14      /* Can not be placed on probation       */
#define PFL_FROB	15	/* Can frob and 17-18 works on others	*/
#define PFL_CH_SCORE	16	/* May change score			*/
#define PFL_CH_LEVEL	17	/* May change level			*/
#define PFL_CH_MDATA	18	/* May change mobile data		*/
#define PFL_CLONE	19	/* May use the CLONE command		*/
#define PFL_LD_STORE	20	/* May use the LOAD and STORE commands	*/
#define	PFL_PFLAGS	21	/* May set privileges on others		*/
#define PFL_MASK	22	/* May set priveliges in MASK		*/
#define PFL_ROOM	23	/* May set location bits and exits	*/
#define PFL_MFLAGS	24	/* May set mobile bits			*/
#define PFL_OBJECT	25	/* May set object properties with SET	*/
#define PFL_TITLES	26	/* May set titles/setins permanently	*/
#define PFL_UAF		27	/* May get/set data for players not on	*/
#define PFL_EXOR	28	/* May exorcise players			*/
#define PFL_RESET	29	/* May reset the game			*/
#define PFL_SHUTDOWN	30	/* May use Opengame and Shutdown	*/
#define PFL_SNOOP	31	/* May snoop or trace other players	*/
#define PFL_HEAL	32	/* May use Heal				*/
#define PFL_ALIAS	33	/* May alias mobiles			*/
#define PFL_ALIASP	34	/* May alias other players		*/
#define PFL_RAW		35	/* May send Raw messages		*/
#define PFL_EMOTE	36	/* May use Emote			*/
#define PFL_ECHO	37	/* May use Echo and Echoall		*/
#define PFL_ZAP		38	/* May use Zap				*/
#define PFL_RES		39	/* May use Resurrect			*/
#define PFL_SEEHOST	40	/* Can see other players hosts		*/
#define PFL_STATS	41	/* May use STAT and SHOW and PRIVS	*/
#define PFL_GOTO	42	/* May use GOTO and IN/AT		*/
#define PFL_SUMOBJ	43	/* May summon objects			*/
#define PFL_WEATHER	44	/* May control the weather		*/
#define PFL_LOCK	45	/* May lock the game			*/
#define PFL_WRECK	46	/* May wreck doors (don't need key)	*/
#define PFL_PEACE	47	/* May declare peace or war		*/
#define PFL_SYSLOG	48	/* May look at the system log-file	*/
#define PFL_STARTINVIS	49	/* May start as invisible		*/
#define PFL_TRACE	50	/* May trace players/objects		*/
#define PFL_PUNT	51	/* May punt players 			*/
#define PFL_EFLAGEDIT	52	/* Can use eflag editor			*/
#define PFL_SFLAGSEE	53	/* Can see sflags			*/
#define PFL_IGNORENOAT	54	/* Can override 'NoAt' lflag		*/
#define PFL_TIMEOUT	55	/* Can timeout users			*/
#define PFL_REBOOT	56	/* Can reboot the MUD			*/
#define PFL_TEXTRAW	57	/* Can use TextRaw			*/
#define PFL_PZAP	58	/* Can PZap (pretend Zap)		*/
#define PFL_SIGNAL	59	/* Can call SIGNAL			*/
#define PFL_BURN	60	/* Can burn other players		*/
#define PFL_SEEUSER	61	/* Can see username from Ident		*/
#define PFL_CANLOG	62	/* Can write to the Mudlog		*/
#define PFL_SIC		63	/* Can sic mobiles on players		*/
#define PFL_FLIST	64	/* Can use the ForgetList command	*/
#define	PFL_NFLAGEDIT	65	/* Can edit Nflags			*/
#define	PFL_SETTIME	66	/* Can set the climate time		*/
#define PFL_CHATMOD	67	/* Chat line moderator			*/
#define PFL_SOCKET	68	/* Can view/edit socket information	*/
#define PFL_IDLE	69	/* Pretending to be idle		*/
#define PFL_SEEANON	70	/* Can see people on the anon channel	*/
#define PFL_NOTIMEOUT	71	/* Cannot be tout'd			*/
#define PFL_NOECHO	72	/* Will not see echo's, echoall's, etc	*/
#define PFL_SEEIDLE	73	/* Can see real idle times		*/
#define PFL_VIEWCOM	74	/* Can see player input handlers	*/
#define PFL_SEESOCKET	75	/* Can see socket activity		*/
#define PFL_BAN		76	/* Can use the BAN command		*/
#define	PFL_PUNTALL	77	/* Can use the PUNTALL command		*/
#define PFL_ABERCHAT    78      /* Can use AberChat                     */
#define PFL_PROBATION   79      /* Can use the probation command        */
#define PFL_SFLAGEDIT   80      /* Can unconditionally edit sflags      */
#define PFL_CODER       81      /* MUD Coder                            */
#define PFL_MAX		96	/* Maximum Pflag			*/

#endif

